using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace ClipboardExample
{
   public class Utility
   {
      public static void PutInClipboard(object data)
      {
         DataObject dataObject = new DataObject();
         // Put serialized to DataObject
         using (MemoryStream stream = new MemoryStream())
         {
            // Allow any serialization errors to be thrown and caught higher in the stack
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(stream, data);
            dataObject.SetData(DataFormats.Serializable, stream.ToArray());
         }
         dataObject.SetText(data.ToString());
         dataObject.SetData("CustomFormat", data);
         Clipboard.SetDataObject(dataObject);
         //// Put serialized to Clipboard
         //using (MemoryStream stream = new MemoryStream())
         //{
         //   // Allow any serialization errors to be thrown and caught higher in the stack
         //   BinaryFormatter formatter = new BinaryFormatter();
         //   formatter.Serialize(stream, data);
         //   Clipboard.SetData(DataFormats.Serializable, stream.ToArray());
         //}
         //Clipboard.SetData(DataFormats.Text, data.ToString());
      }

      public static object GetFromClipboard()
      {
         object obj = Clipboard.GetData("CustomFormat");
         // Get serialized from clipboard
         if (Clipboard.ContainsData(DataFormats.Serializable))
         {
            using (MemoryStream stream = new MemoryStream((Byte[])Clipboard.GetData(DataFormats.Serializable)))
            {
               stream.Position = 0;
               BinaryFormatter formatter = new BinaryFormatter();
               return formatter.Deserialize(stream);
            }
         }
         return null;
      }
   }
}
